﻿using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using System.Web.Security;
using FluentSecurity;
using FluentSecurity.Caching;

namespace CommonHotelApplication
{
    public class MvcApplication : HttpApplication
    {
        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();
            RouteConfig.RegisterRoutes(RouteTable.Routes);
            SecurityConfigurator.Configure(configuration =>
            {
                configuration.Advanced.SetDefaultResultsCacheLifecycle(Cache.PerHttpRequest);
                configuration.GetAuthenticationStatusFrom(() => HttpContext.Current.User.Identity.IsAuthenticated);
                configuration.GetRolesFrom(Roles.GetRolesForUser);
                configuration.ForAllControllersInheriting<Controllers.BaseController>().DenyAnonymousAccess();
                configuration.For<Controllers.SGAccountController>(c => c.LogOn()).Ignore();
                configuration.For<Controllers.SGAccountController>(c => c.ForgotPassword()).Ignore();
                configuration.For<Controllers.SGAccountController>(c => c.ForgotPasswordSuccess()).Ignore();
            });
            GlobalFilters.Filters.Add(new HandleSecurityAttribute(), 0);
        }
    }
}
