﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Model.Entities
{
    public class User
    {
        [Key, DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int UserId { get; set; }

        public string Username { get; set; }

        public string FirstName { get; set; }

        public string LastName { get; set; }

        public string Email { get; set; }

        public byte[] PasswordSalt { get; set; }

        public byte[] PasswordHash { get; set; }

        public string AutoPassword { get; set; }

        public string PasswordQuestion { get; set; }

        public string PasswordAnswer { get; set; }

        public string Comment { get; set; }

        public bool IsApproved { get; set; }

        public DateTime DateCreated { get; set; }

        public DateTime? DateLastActivity { get; set; }

        public DateTime? DateLastLogin { get; set; }

        public DateTime DateLastPasswordChange { get; set; }

        public virtual ICollection<Role> Roles { get; set; }
    }
}
